#problem MASTER;
param NPLANT ;
param NDEMAND ;
param alpha {k in 1..NCUT, i in 1..NPLANT};
param beta {k in 1..NCUT};
param alpha1 {k in 1..NfeaCUT, i in 1..NPLANT};
param beta1 {k in 1..NfeaCUT};
param xx {i in 1..NPLANT};

var x {i in 1..NPLANT} >=0, integer;
var theta >=0;

param fixcost {i in 1..NPLANT}>=0;
param demand {j in 1..NDEMAND}>=0;
param caplimit {i in 1..NPLANT}>=0; 
param l {i in 1..NPLANT};
param u {i in 1..NPLANT};

minimize costmaster: 
sum {i in 1..NPLANT}fixcost[i]*x[i] +theta;

subject to luz {i in 1..NPLANT}:
 l[i] <= x[i] <= u[i];

subject to feascut {k in 1..NfeaCUT}:
0>=sum{i in 1..NPLANT}alpha1[k,i]*x[i] +beta1[k];

subject to optcut {k in 1..NCUT}:
theta >= sum{i in 1..NPLANT}alpha[k,i]*x[i] +beta[k];

subject to feasibility:
 sum {i in 1..NPLANT}caplimit[i]*x[i]  >= sum {j in 1..NDEMAND}demand[j];


#problem SECOND;
var y {i in 1..NPLANT, j in 1..NDEMAND}>=0;
param varcost {i in 1..NPLANT, j in 1..NDEMAND}>=0;

minimize secondcost: 
sum {i in 1..NPLANT, j in 1..NDEMAND} varcost[i,j]*y[i,j];

subject to capacity {i in 1..NPLANT}:
 -sum {j in 1..NDEMAND}y[i,j] >= -caplimit[i]*xx[i];

subject to dem1 {j in 1..NDEMAND}:
 sum {i in 1..NPLANT}y[i,j]  = demand[j];

#problem DIRECTION;  #[͏ȗ
var mu {i in 1..NPLANT};
var pi {j in 1..NDEMAND};

maximize directgen:
sum {i in 1..NPLANT} caplimit[i]*xx[i]*mu[i]
+sum {j in 1..NDEMAND} demand[j]*pi[j];

subject to direct_mupi {i in 1..NPLANT, j in 1..NDEMAND}:
 mu[i]+pi[j] <=0;
subject to direct_mu {i in 1..NPLANT}:
 -1<= mu[i] <=0;
subject to direct_pi {j in 1..NDEMAND}:
 -1<= pi[j] <=1;




